setlocal enabledelayedexpansion
setlocal enableextensions

@rem Versione 1.0 - Andrea 18 nov 2016
@rem ---------------------------------

rem echo off

@rem ------------------------
@rem test administrator right 
@rem ------------------------
@net session >nul 2>&1
@if %errorLevel% NEQ 0 (
	@echo --------------------------------------------------------------------
	@echo ERRORE: richiede di essere eseguito con i permessi di amministratore
	@echo --------------------------------------------------------------------
	@goto STOP
) 

@rem --------------------------------------------------------------------
@rem Determina da dove  lanciato lo script per la call al bat dei backup
@rem --------------------------------------------------------------------
@set DRIVE=%~dp0
@set DRIVELETTER=%~d0
@set DRIVEP=%drive%
@if #%drive:~-1%# == #\# set DRIVEP=%drive:~0,-1%

@set FLGRO=0
@set NRVOLUME=undef
@set LETTERA=undef
@set LABEL=undef

start /min diskpart.exe 

@echo list volume >  script.txt
@echo EXIT        >> script.txt

@for /f "skip=8 tokens=2,3,4 delims= " %%a in ('diskpart /s script.txt') do (
    set NRVOLUME=%%a
	set LETTERA=%%b
    set LABEL=%%c

	@echo -------------------------------------------------------------
	@echo Analizzo il NrVolume:!NRVOLUME!  Lettera:!LETTERA!  Label:!LABEL!
	@echo -------------------------------------------------------------
	
	@if /I "!LABEL!" == "DiscoRO" (
		@set FLGRO=1

        @echo ----------------------------
        @echo sblocca il volume !NRVOLUME!
        @echo ----------------------------
        @rem --- Uso DISK perch non  supportato Volumes sui supporti rimovibili
        @rem --- selezionando il volume viene selezionato anche il disco attivo
        @echo SELECT VOLUME !NRVOLUME!         >  %TMP%\diskpart_enableRW.txt
        @echo ATTRIBUTES DISK CLEAR READONLY   >> %TMP%\diskpart_enableRW.txt
        @echo EXIT                             >> %TMP%\diskpart_enableRW.txt
        @echo SELECT VOLUME !NRVOLUME!         >  %TMP%\diskpart_enableRO.txt
        @echo ATTRIBUTES DISK SET   READONLY   >> %TMP%\diskpart_enableRO.txt
        @echo EXIT                             >> %TMP%\diskpart_enableRO.txt
          
        @echo --------------------
        @echo Abilito la scrittura
        @echo --------------------
        diskpart /s %TMP%\diskpart_enableRW.txt
        if !ERRORLEVEL! NEQ 0 (
			@echo ---------------------------------------------------------------------------
			@echo ERRORE nello sblocco del Volume !NRVOLUME! ...premi un tasto per continuare
			@echo ---------------------------------------------------------------------------
			@goto STOP
        )
        timeout /t 20
        
        @rem --- se voglio salvare i BAT Blocco / sblocco unit
        @copy %TMP%\diskpart_enableRW.txt !LETTERA!:\diskpart_enableRW.txt
        @copy %TMP%\diskpart_enableRO.txt !LETTERA!:\diskpart_enableRO.txt
        @echo diskpart /s .\diskpart_enableRW.txt > !LETTERA!:\diskpart_enableRW.bat
        @echo diskpart /s .\diskpart_enableRO.txt > !LETTERA!:\diskpart_enableRO.bat
	)

	set FLGOK=0
	@if /I "!LABEL!" == "DiscoR" (
		@set FLGOK=1
		@echo Label DiscoR
	)
	@if /I "!LABEL!" == "DiscoRO" (
		@set FLGOK=1
		@echo Label DiscoRO
	)
	@if "!FLGOK!" == "1" (
		@if /I NOT "!LETTERA!" == "R" (
			@echo ------------------------------------------------------------------------------
			@echo Assegna lettera R al Volume: !NRVOLUME! invece dell'attuale Lettera: !LETTERA!
			@echo ------------------------------------------------------------------------------
			@echo select volume !NRVOLUME! > %TMP%\assignR.txt
			@echo assign letter = R >> %TMP%\assignR.txt
			diskpart /s %TMP%\assignR.txt 
			@rem --- ok, assegno la nuova lettera R
			set LETTERA=R
			@timeout /t 15
		)
		@echo Controlli finali FLGOK:!FLGOK! e Lettera:!LETTERA! ....
	)
	@if "!FLGOK!" == "1" (
		@if /I "!LETTERA!" == "R" (
			@echo --------------------------
			@echo Tutto OK: lancio il backup
			@echo --------------------------
			@goto BACKUP
		) else (
			@echo ma dove diavolo sono finito?
			@echo pause
		)
	)
)
goto FINE
	
@rem ---------------
@rem Attivare backup
@rem ---------------
:BACKUP
	@echo backup
	call %DRIVEP%\aggiorna_red.bat
	@if %ERRORLEVEL% NEQ 0 (
		@echo -----------------
		@echo ERRORE nel backup
		@echo -----------------
		@pause
	)
	
:FINE
	@rem ---------------------------
	@rem se RO riattivare protezione
	@rem ---------------------------
	@if "!FLGRO!"=="1" (
		call :SUB_LOOKPARTITION
		echo -----------------------
		echo Disabilitola scrittura
		echo -----------------------
		diskpart /s %TMP%\diskpart_enableRO.txt
		if %ERRORLEVEL% NEQ 0 (
			@echo ------------------------------------------------------------------
			@echo ERRORE nel blocco della partizione...premi un tasto per continuare
			@echo ------------------------------------------------------------------
			@pause
		)
		timeout /t 15
	)
	timeout /t 5
	
	@echo ----------------------------------------------------------
	@echo Chiude le istanze di diskpart eventualmente rimaste aperte
	@echo ----------------------------------------------------------
	taskkill /f /im diskpart.exe
	@echo FINE

:STOP
	@echo --------------------
	@echo FINE: premi un tasto
	@echo --------------------
	@pause
